<template>
  <v-container>
    <v-form>
      <v-container>
        <v-row>
          <v-col cols="12" md="4">
            <v-text-field
              v-model="code"
              :counter="10"
              label="Code"
              required
              outlined
            ></v-text-field>
          </v-col>

          <v-col cols="12" md="4">
            <v-text-field
              v-model="name"
              :counter="10"
              label="Name"
              required
              outlined
            ></v-text-field>
          </v-col>

          <v-col cols="12" md="4">
            <v-text-field
              v-model="email"
              :counter="10"
              label="Email"
              required
              outlined
            ></v-text-field>
          </v-col>

          <v-col cols="12" md="6">
            <v-text-field
              v-model="pwd"
              label="Password"
              type="password"
              outlined
              clearable
            />
          </v-col>

          <v-col cols="12" md="4">
            <v-btn @click="doSave">Save</v-btn>
          </v-col>
        </v-row>
      </v-container>
    </v-form>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue'
import { mapActions, mapGetters } from 'vuex'
export default Vue.extend({
  data() {
    return {
      code: '',
      name: '',
      email: '',
      pwd: '',
    }
  },
  computed: mapGetters({
    user: 'user/user',
    isEdit: 'user/isEdit',
    id: 'user/id',
  }),
  methods: {
    doSave() {
      if (this.isEdit) {
        this.updateUser({
          id: this.id,
          body: {
            code: this.code,
            email: this.email,
            name: this.name,
            pwd: this.pwd,
          },
        }).then((_) => this.$router.back())
      } else {
        this.createUser({
          code: this.code,
          email: this.email,
          name: this.name,
          pwd: this.pwd,
        }).then((_) => this.$router.back())
      }
    },
    setUserFormData() {
      if (this.isEdit) {
        this.code = this.user.code
        this.name = this.user.name
        this.email = this.user.email
        this.pwd = this.user.pwd
      }
    },
    ...mapActions({
      createUser: 'user/createUser',
      updateUser: 'user/updateUser',
    }),
  },
  mounted() {
    this.setUserFormData()
  },
})
</script>